#!/bin/sh
# %%% Package  Version 2001.1.1       2001.10.18
# %%% original version 1998.2.0       1998.10.9
# script for testing package for all/each categories with plain/latex 1998.9
#                                aoki@hep.s.kanazawa-u.ac.jp 
#                                uehara@yukawa.kyoto-u.ac.jp 
# check debug.doc first

# set mode of check
TEX=1
LATEX=1
PRE=0
PRINT=0

# set local commands to call
texcmd=ptex
latexcmd=platex
precmd=xdvi

# set print command. 
# "pr_script" should send a dvi_file directly to a printer
pr_script=dvi2lp

## if you want to pipe dvifiler to printcomand 
## 1) uncomment  USEPIPE_FOR_PR=1
## 2) set dvifilter and lpcmd properly

#USEPIPE_FOR_PR=1
dvitops=dvips
lpcmd=lpr

#####  end of site dependent part ######
########################################
program=`basename $0`
usage (){
exec 1>&2
echo "usage:  $program [options]"
echo '
    option: 
           -h      : this help
           -l [LTX]: latex only, no tex (run LTX for LaTeXing)
           -t [TeX]: tex only, no latex (run TeX for TeXing)
           -p      : print
           -v      : preview
	   -a      : complie whole sets (default)
           -1      : compile ף£ð
           -2      : compile 
           -3      : compile ˨
           -4      : compile 
           -5      : compile ףô
           -6      : compile ײ
           -7      : compile ף³
           -8      : compile ף


'
exit 1
}

###
numreset() {
    if [ $ALLFIELD = 1 ]; then
	ALLFIELD=0
	ABC_K=0;WAKAB=0;HOUGA=0;TOKUT=0;CKIKA=0;TOKUK=0;KAIGA=0;KBANS=0;
    fi
}
###
prtdvi () {
    if [ x$USEPIPE_FOR_PR = x1 ]; then
	$dvifilter $1.dvi | $lpcmd
	if [ x$itm = xKBANS ]; then
	    $dvifilter $1-s.dvi | $lpcmd
	fi
    else
	$pr_script $1
	if [ x$itm = xKBANS ]; then
	    $pr_script $1-s.dvi
	fi
    fi
}

###
runtex () {
    $texcmd $1.tex
    if [ x$itm = xKBANS ]; then
    [ -f benchcompile.fileset ] && /bin/rm -f benchcompile.fileset
	$texcmd $1-s.tex
    fi
}

runlatex () {
    $latexcmd $1.tex
    if [ x$itm = xKBANS ]; then
    [ -f benchcompile.fileset ] && /bin/rm -f benchcompile.fileset
	$latexcmd $1-s.tex
    fi
}


ALLFIELD=1
SRC=0;TCMD=0;LTCMD=0
texsrc=src

for arg in `echo ---DummY "$@"`
do
    case $arg in
    -t|-T)  TEX=1;LATEX=0;SRC=0;TCMD=1;LTCMD=0 ;;
    -l|-L)  TEX=0;LATEX=1;SRC=0;TCMD=0;LTCMD=1 ;;
    -s|-S)  SRC=1;TCMD=0;LTCMD=0 ;;
    -s*|-S*)
	    texsrc=`echo "x$arg"|sed 's/^x-s//;s/\.tex$//'` ;;
    ---DummY) ;;
    -|--*) usage;;
    -*)
	for i in `echo "x$arg"|sed -e 's/^x-//' -e 's/\(.\)/\1 /g'`
	do
	case $i in
	1) numreset && [ x$ABC_K = x0 ] && ABC_K=1 && SUB="$SUB ABC_K" ;;
	2) numreset && [ x$WAKAB = x0 ] && WAKAB=1 && SUB="$SUB WAKAB" ;;
	3) numreset && [ x$HOUGA = x0 ] && HOUGA=1 && SUB="$SUB HOUGA" ;;
	4) numreset && [ x$TOKUT = x0 ] && TOKUT=1 && SUB="$SUB TOKUT" ;;
	5) numreset && [ x$CKIKA = x0 ] && CKIKA=1 && SUB="$SUB CKIKA" ;;
	6) numreset && [ x$TOKUK = x0 ] && TOKUK=1 && SUB="$SUB TOKUK" ;;
	7) numreset && [ x$KAIGA = x0 ] && KAIGA=1 && SUB="$SUB KAIGA" ;;
	8) numreset && [ x$KBANS = x0 ] && KBANS=1 && SUB="$SUB KBANS" ;;
	a|A) ;;
	l|L) TEX=0;LATEX=1;;
	p|P) PRINT=1 ;;
	t|T) TEX=1;LATEX=0;;
	v|V) PRE=1 ;;
	*) usage;;
	esac
	done
	;;
    *)
	if [ x$SRC = x1 ]; then
	    texsrc=`echo $arg|sed 's/\.tex$//'`
	elif [ x$TCMD = x1 ]; then
	    texcmd=$arg
	elif [ x$LTCMD = x1 ]; then
	    latexcmd=$arg
	else
	    usage
	fi
	SRC=0;TCMD=0;LTCMD=0;;
    esac
done

##########################################
if [ $ALLFIELD = 1 ]; then
    SUB="ABC_K WAKAB HOUGA TOKUT CKIKA TOKUK KAIGA KBANS"
fi
texok=0
trap "/bin/rm -f benchcompile.fileset; exit 1" 1 2 3 9 15
for itm in $SUB
do
    sed -e '1,/^%%debug_tool/d;/^%%end_of_debug_tool/,$d' \
    -e "s@\def\\\\\(.*\){}  *%%%$itm@\1@;s@^%%@@" kkhgrp.mac > benchcompile.fileset
    [ x$TEX = x1 ] && runtex $texsrc && texok=1
    [ x$LATEX = x1 ] && runlatex $texsrc && texok=1
    [ x$PRE = x1 -a $texok = 1 ] && $precmd $texsrc.dvi
    [ x$PRINT = x1 -a $texok = 1 ] && prtdvi $texsrc
done
[ -f benchcompile.fileset ] && /bin/rm benchcompile.fileset
